// axios配置  可自行根据项目进行更改，只需更改该文件即可，其他文件可以不动
// The axios configuration can be changed according to the project, just change the file, other files can be left unchanged

import type { AxiosResponse } from 'axios';
import type { RequestOptions, Result } from '/#/axios';
import type { AxiosTransform, CreateAxiosOptions } from './axiosTransform';
import { VAxios } from './Axios';
import { checkStatus } from './checkStatus';
import { useGlobSetting } from '/@/hooks/setting';
import { useMessage } from '/@/hooks/web/useMessage';
import { RequestEnum, ContentTypeEnum } from '/@/enums/httpEnum';
import { isString } from '/@/utils/is';
import { getJwtToken } from '/@/utils/auth';
import { setObjToUrlParams, deepMerge } from '/@/utils';
import { useErrorLogStoreWithOut } from '/@/store/modules/errorLog';
import { useI18n } from '/@/hooks/web/useI18n';
import { joinTimestamp, formatRequestDate } from './helper';
import { getAppEnvConfig } from '/@/utils/env';
import { PageEnum } from '/@/enums/pageEnum';
import { router } from '/@/router';
import { sm2 } from 'sm-crypto';
import { message } from 'ant-design-vue';
import { useUserStore } from '/@/store/modules/user';



// # 国密私钥(后端加密，前端解密)
const privateKey = 'fe16bcdc8b3e79029984a0a171d5861c58ef9979ed111c01f849f45d165075aa';

// # 国密公钥(后端加密，前端解密)
const publicKey =
  '045856c11a3d540e73c86a761c72ec19d2f9bb5aee1c037b38656928e574a507c62d473cccb51023e9ad754d8aff1c5c607de20dff36ca54f6d082a2af6de1187a';
const globSetting = useGlobSetting();
const urlPrefix = globSetting.urlPrefix;
const { createMessage, createErrorModal } = useMessage();

const serverPrivateKey =
  'MIGTAgEAMBMGByqGSM49AgEGCCqBHM9VAYItBHkwdwIBAQQg+wXh31HLGQ2+hUYUoTiEaHJPBUoz1GxHJrLxvVub1xKgCgYIKoEcz1UBgi2hRANCAARYVsEaPVQOc8hqdhxy7BnS+bta7hwDezhlaSjldKUHxi1HPMy1ECPprXVNiv8cXGB94g3/NspU9tCCoq9t4Rh6';
const serverPublicKey =
  'MFkwEwYHKoZIzj0CAQYIKoEcz1UBgi0DQgAETXeVRYS/SQ7gIvtuwpNBPin2OGLJJ7Kaeq/IuukHSltOCjsltymggv/juPBLJb9x02rw0uF5unTXXrc1bQ+V3w==';

window.jm = function (res) {
  return sm2.doDecrypt(res, serverPublicKey);
};
/**
 * @description: 数据处理，方便区分多种处理方式
 */
const transform: AxiosTransform = {
  /**
   * @description: 处理请求数据。如果数据不是预期格式，可直接抛出错误
   */
  transformRequestHook: (res: AxiosResponse<Result>, options: RequestOptions) => {
    const { isReturnNativeResponse } = options;
    // 是否返回原生响应头 比如：需要获取响应头时使用该属性
    if (isReturnNativeResponse) {
      return res;
    }
    return res.data;
  },

  // 请求之前处理config
  beforeRequestHook: (config, options) => {
    const { isSw, apiUrl, ligongApiUrl, debuggerApiUrl, joinPrefix, joinParamsToUrl, formatDate, joinTime = true } = options;

    if (joinPrefix) {
      config.url = `${urlPrefix}${config.url}`;
    }

    if (apiUrl && isString(apiUrl)) {
      if (config.ligong) {
        config.url = `${ligongApiUrl}${config.url}`;
      } else if (config.isDebugger) {
        config.url = `${debuggerApiUrl}${config.url}`;
      } else {
        config.url = `${apiUrl}${config.url}`;
      }
    }
    if (isSw) {
      config.url = `${config.url}`;
    }
    const params = config.params || {};
    const data = config.data || false;
    formatDate && data && !isString(data) && formatRequestDate(data);
    if (config.method?.toUpperCase() === RequestEnum.GET) {
      if (!isString(params)) {
        // 给 get 请求加上时间戳参数，避免从缓存中拿数据。
        config.params = Object.assign(params || {}, joinTimestamp(joinTime, false));
      } else {
        // 兼容restful风格
        config.url = config.url + params + `${joinTimestamp(joinTime, true)}`;
        config.params = undefined;
      }
    } else {
      if (!isString(params)) {
        formatDate && formatRequestDate(params);
        if (config.data instanceof FormData) {
          config.data = data;
          config.params = params;
        } else if (Reflect.has(config, 'data') && config.data && Object.keys(config.data).length > 0) {
          config.data = data;
          config.params = params;
        } else {
          // 非GET请求如果没有提供data，则将params视为data
          config.data = params;
          config.params = undefined;
        }
        if (joinParamsToUrl) {
          config.url = setObjToUrlParams(config.url as string, Object.assign({}, config.params, config.data));
        }
      } else {
        // 兼容restful风格
        config.url = config.url + params;
        config.params = undefined;
      }
    }
    let rs = '';
    // 请求拦截器参数加密
    if (typeof config.data != 'undefined' && config.data && config.ligong) {
      rs = sm2.doEncrypt(JSON.stringify(config.data), publicKey); // 加密结果
      config.data = rs;
    } else if (typeof config.params != 'undefined' && config.params && config.ligong) {
      if (config.url.indexOf('/zhjc/monitor/chart') > -1) {
        rs = sm2.doEncrypt(JSON.stringify(config.params.sensorRelationCode), publicKey); // 加密结果
        // config.url = config.url + '/' + rs;
        // delete config.params;
        config.params = {
          param: rs,
        };
      } else {
        rs = sm2.doEncrypt(JSON.stringify(config.params), publicKey); // 加密结果
        config.params = {
          param: rs,
        };
      }
    }
    return config;
  },

  /**
   * @description: 请求拦截器处理
   */
  requestInterceptors: (config, options) => {
    // 请求之前处理config
    const token = getJwtToken();

    if (token && (config as Recordable)?.requestOptions?.withToken !== false) {
      // jwt token
      config.headers['X-Authorization'] = options.authenticationScheme ? `${options.authenticationScheme} ${token}` : token;
    }
    if (config.ligong) {
      const ligongToken = JSON.parse(sessionStorage.getItem('ligongToken'));
      config.headers['Authorization'] = ligongToken;
      config.headers['X-Access-Token'] = ligongToken;
      config.headers['X-Sign'] = '239D943E6EF1E33BDC18BDED629CBE55';
      config.headers['X-Version'] = 'v3';
    }
    return config;
  },

  /**
   * @description: 响应拦截器处理
   */
  responseInterceptors: (res: AxiosResponse<any>) => {
    // 响应拦截器参数解密
    if (typeof res.data != 'undefined' && res.data && res.config.ligong) {
      const deData = sm2.doDecrypt(res.data.slice(2), privateKey); // 解密结果
      if (deData != '') {
        res.data = JSON.parse(deData);
      } else {
        res.data = deData;
      }
      if (res.data.code != 200) {
        console.log('理工请求报错：', res.data);
        // message.warning(res.data.message);
      }
    }
    return res;
  },

  /**
   * @description: 响应错误处理
   */
  responseInterceptorsCatch: (error: any) => {
    const { t } = useI18n();
    const errorLogStore = useErrorLogStoreWithOut();
    errorLogStore.addAjaxErrorInfo(error);
    const { response, code, message, config } = error || {};

    const errorMessageMode = config?.requestOptions?.errorMessageMode || 'none';
    const errorMsgIsObj = typeof response?.data === 'object';
    const msg: string = errorMsgIsObj ? response?.data?.message || response?.data?.msg : response?.data;
    const err: string = error?.toString?.() ?? '';
    let errMessage = '';
    try {
      if (response?.status == '401' || response?.data?.status == '401' || response?.data?.message == '"Authentication failed"') {
        window.localStorage.clear();
        window.sessionStorage.clear();
        // router.push(PageEnum.BASE_HOME);//之前路由返回的地址
        const { VITE_GLOB_ADMIN_LOGIN, VITE_GLOB_IS_IDC } = getAppEnvConfig();
        if (VITE_GLOB_IS_IDC && VITE_GLOB_IS_IDC.length) {
          useUserStore().logout()
        } else {
          window.location.href = VITE_GLOB_ADMIN_LOGIN;
        }
      }
      if (code === 'ECONNABORTED' && message.indexOf('timeout') !== -1) {
        // errMessage = t('sys.api.apiTimeoutMessage');
        console.log(t('sys.api.apiTimeoutMessage'));
      }
      if (err?.includes('Network Error')) {
        errMessage = t('sys.api.networkExceptionMsg');
      }

      if (errMessage) {
        if (errorMessageMode === 'modal') {
          createErrorModal({ title: t('sys.api.errorTip'), content: errMessage });
        } else if (errorMessageMode === 'message') {
          createMessage.error(errMessage);
        }
        return Promise.reject(error);
      }
    } catch (error: any) {
      throw new Error(error);
    }
    checkStatus(error?.response?.status, msg, errorMessageMode);
    return Promise.reject(response ? response.data : {});
  },
};

function createAxios(opt?: Partial<CreateAxiosOptions>) {
  let joinPrefix = true;
  let apiUrl = globSetting.apiUrl;
  const transformTemp = transform;
  if (opt) {
    if (typeof opt.joinPrefix == 'boolean') {
      joinPrefix = opt.joinPrefix;
    }
    if (typeof opt.apiUrl != 'undefined' && typeof opt.apiUrl == 'string') {
      apiUrl = opt.apiUrl;
    }
    // if(typeof(opt.apiUrl)!="undefined"){
    //   transformTemp=opt.transform;
    // }
  }

  return new VAxios(
    deepMerge(
      {
        // See https://developer.mozilla.org/en-US/docs/Web/HTTP/Authentication#authentication_schemes
        // authentication schemes，e.g: Bearer
        // authenticationScheme: 'Bearer',
        authenticationScheme: 'Bearer',
        timeout: 50 * 1000,
        // 基础接口地址
        // baseURL: globSetting.apiUrl,
        // 接口可能会有通用的地址部分，可以统一抽取出来
        urlPrefix: urlPrefix,
        headers: { 'Content-Type': ContentTypeEnum.JSON },
        // 如果是form-data格式
        // headers: { 'Content-Type': ContentTypeEnum.FORM_URLENCODED },
        // 数据处理方式
        transform: transformTemp,
        // 配置项，下面的选项都可以在独立的接口请求中覆盖
        requestOptions: {
          // 默认将prefix 添加到url
          joinPrefix: joinPrefix,
          // 是否返回原生响应头 比如：需要获取响应头时使用该属性
          isReturnNativeResponse: false,
          // 需要对返回数据进行处理
          isTransformResponse: true,
          // post请求的时候添加参数到url
          joinParamsToUrl: false,
          // 格式化提交参数时间
          formatDate: true,
          // 消息提示类型
          errorMessageMode: 'message',
          // 接口地址
          apiUrl: apiUrl,
          //理工接口地址
          ligongApiUrl: globSetting.ligongApiUrl,
          //理工接口地址
          debuggerApiUrl: globSetting.debuggerApi,
          //  是否加入时间戳
          joinTime: true,
          // 忽略重复请求
          ignoreCancelToken: true,
          // 是否携带token
          withToken: true,
        },
      },
      opt || {}
    )
  );
}
export const defHttp = createAxios();

// other api url
export const otherHttp = createAxios({
  requestOptions: {
    apiUrl: 'xxx',
  },
});

export const defHttpFun = createAxios;
